<?


if(!class_exists('IRetailAPI'))
{
	class IRetailAPI
	{

		public static function getLogFileName()
		{
			// if (class_exists('ControllerModuleIRetailOCIRetailApi'))
			if (file_exists(__DIR__.'/ociretailapi.php'))
				return DIR_LOGS.'/iretail.log';
			else
				return __DIR__.'/iretail.log';
		}
		public static function getLog()
		{
			return @file_get_contents(self::getLogFileName());
		}
		public static function clearLog()
		{
			return @unlink(self::getLogFileName());
		}

		public static function notifyErr($order_id,$title,$data=null)
		{
			$message="Произошла ошибка при фискализации заказа {order_id} из интернет-магазина {host}:\n{title}";
			if ($data)
				$message.="\n\nОтвет от сервера:\n{data}";
			self::notify('err',$message,['order_id'=>$order_id,'title'=>$title,'data'=>$data]);
		}
		public static function notify($type,$message,$data=[])
		{
			$subject=false;
			if ($type=="err" && in_array(self::$notifymode,['err','all']))
				$subject='Уведомление об ОШИБКЕ взаимодействия';
			elseif ($type=="ok" && self::$notifymode=='all')
				$subject='Уведомление о взаимодействии';
			$data['host']= parse_url($_SERVER['HTTP_HOST'],PHP_URL_HOST);

			if ($subject)
			{
				$message=self::replaceKeys($message, $data);
				self::$mailer->notify($subject.' '.$data['host'].' и iRetail.com',$message);
			}

		}
		public static function debug($s)
		{
			if (self::$debug) self::logAdd($s);
		}
		public static function log($s)
		{
			if (self::$log || self::$debug) self::logAdd($s);
		}

    public static function logAdd($s)
    {
     	$s=date('c').' '.$s."\n\n";
    	file_put_contents(self::getLogFileName(),$s,FILE_APPEND);
    }

    public static $power,$mode,$debug,$log,$login,$apikey,$printmode,$notifymode,$mailer;
    public static function config($params=[])
    {
    	foreach ($params as $k=>$v)
    	{
    		self::$$k=$v;
    	}
    }

    public static $aPrintModes=[
    	'print'=>'Распечатать чек',
      'email'=>'Отправить электронный чек по email и/или смс',
      'print_email'=>'Распечатать чек и отправить по email и/или смс'];
    public static $aNotifyModes=[
    	'no'=>'Без уведомлений',
      'err'=>'Оповещение об ошибках',
      'all'=>'Оповещение обо всех результатах'];

    ///////////////////////////////////////////

	    public static function request($data)
	    {
	    	$requestId='request'.uniqid().rand(1000,9999);

	    	$ret=null;

				self::debug($requestId.' data='.print_r($data,1));

		    $urls = [
		        'test' => 'https://nightlybuilds.i-retail.freematiq.com/api/cloud-fiscal/order/create',
		        'prod' => 'https://kassa.i-bonus.me/api/cloud-fiscal/order/create'
		    ];

				$data['login']=self::$login;
				$data['api_key']=self::$apikey;

				if (!empty(self::$printmode)) //необязательный
					$data['mode']=self::$printmode;
				if (!isset($data['type']))
					$data['type']='payment';

				// $data['cash_amount']=0;
				// $data['mc_amount']=0;

				if ((int)self::$mode)
					$url=$urls['prod'];
				else
					$url=$urls['test'];

		    $curl = curl_init($url);
			  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			  curl_setopt($curl, CURLOPT_POST, true);
			  curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
			  curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			    // curl_setopt($curl, CURLOPT_POSTFIELDS, $queryData);

				$queryData = http_build_query($data, '', '&');
			  curl_setopt($curl, CURLOPT_POSTFIELDS, $queryData);

				self::debug($requestId.' query='.$queryData);
				if (!self::$debug)
	    		self::log($requestId." Отправляем данные заказа ".$data['external_order_id']);

			  $response = curl_exec($curl);
			  $err = curl_error($curl);
			  curl_close($curl);

	    	// var_dump($err,$response);

		    if ($err)
		    {
		    	$ret=['status'=>"CURL ERROR",'result'=>$err,'text'=>'Сетевая ошибка работы с i-Retail.com: '.$err];
		    	self::logAdd($requestId.' '.$ret['text']);
		    	self::notifyErr($data['external_order_id'],$ret['text']);
		    }
		    elseif (!$response)
		    {
		    	$ret=['status'=>"EMPTY ERROR",'result'=>$response,'text'=>'Сетевая ошибка работы с i-Retail.com. Пустой ответ.'];
		    	self::logAdd($requestId.' '.$ret['text']);
		    	self::notifyErr($data['external_order_id'],$ret['text']);
		    }
		    elseif (!($j=json_decode($response,true)))
		    {
		    	$ret=['status'=>"JSON ERROR",'result'=>$response,'text'=>'Некорректный формат ответа от i-Retail.com'];
		    	self::logAdd($requestId.' Ошибка JSON. Ответ: \':'.$response.'\'');
		    	self::notifyErr($data['external_order_id'],$ret['text'],$response);
		    }
		    else
		    {
		    	if ($j['status']==true)
		    	{
		    		if (self::$debug)
		    			self::debug($requestId.' response '.var_export($j,1));
		    		else
		    			self::log($requestId.' Успешный ответ по заказу '.$data['external_order_id']." ".substr(var_export($j['result'],1),5));
		    		$ret=['status'=>"OK",'result'=>$j['result'],'text'=>'Данные успешно переданы на i-Retail.com.'];
			    	self::notify('ok',
							"Заказ номер {external_order_id} из интернет-магазина {host} успешно фискализирован!",
							['external_order_id'=>$data['external_order_id']]);
		    	}
		    	else
		    	{
		    		self::logAdd($requestId.' Ошибка IRETAIL: '.var_export($j,1));
		    		$ret=['status'=>"IRETAIL ERROR",'result'=>$j['result'],'text'=>'Ошибка работы с i-Retail.com: '.substr(var_export($j['result'],1),5)];
			    	self::notifyErr($data['external_order_id'],$j['result']['title'],var_export($j,1));
		    	}
		    }
		    if ($ret['status']!="OK" && !self::$debug)
		    {
					self::logAdd($requestId.' Данные для ошибочного запроса: '.print_r($data,1)."\nЗапрос: ".$queryData."\n-------------\n");
		    }
		    // echo 'end';die;
		    return $ret;
	    }

			public static function replaceKeys($subj,$repl)
		  {
		    if (is_array($subj))
		    {
		      foreach ($subj as $key => $value) {
		        $subj[$key]=self::replaceKeys($value,$repl);
		      }
		    }
		    else
		    {
		      $k=array();
		      foreach ($repl as $key => $value)
		        $k[]='{'.$key.'}';
		      $v=array_values($repl);
		      $subj=str_replace($k,$v,$subj);
		    }
		    return $subj;
		  }	    


	}

	interface IretailMailerInterface {
		function notify($subject, $message);
	}
	trait IretailMailerTrait {
		public $emails;
		function __construct($email) {
			$this->emails=explode(",",trim($email,",. \t\n\r\0\x0B"));
		}
	}
}